      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      include 'PDFCOM.'

      real*8 termplus(20,20,0:50,100),termtotplus(20,20,0:50,100)
     ,      ,termdisp(20,20,100)

      real*8 q2hera(12)
      data q2hera/ 2.5d0, 5d0, 7d0, 12d0, 18d0, 32d0, 60d0
     ,          , 120d0, 200d0, 350d0, 650d0, 2000d0/

      data xmin,xmax,ecm / 1d-5, 1d-1, 319d0/
!      data xmin/ 2d-5, 6d-5, 1d-4, 1.2d-4, 2d-4, 5d-4, 7d-4
!     ,  ,1d-3, 3d-3, 5d-3, 5d-3, 0.01d0/
!      data xmax/ 2d-3, 4d-3, 6d-3, 0.01d0, 0.02d0, 0.03d0, 0.08d0
!     ,  ,0.08d0, 0.08d0, 0.08d0, 0.08d0, 0.08d0/

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2

!  Set the factorization scale as sqrt(Q2*hqscale1 + 4m^2*hqscale2) for the 
!  pair heavy-quark production and as sqrt(Q2*hqscale1 + m^2*hqscale2) for the 
!  single heavy-quark production
      hqscale1=1d0
      hqscale2=1d0

!  Include the correction up to the NNLO for the heavy-quark coefficients
      kordhq=2
      msbarm=.true.
! Set the c-quark mass at the PDG'10 value 
      rmass(8)=1.27
! The non-singlet contribution is included 
      hqnons=.true.
! Variant A of the NNLO term in the heavy-quark electroproduction Wilson 
! coefficient of Ref. [1205.5727] is selected
      ddnnlohq=0. 

      nbin=30

      do kpdfset=0,npdftot
        call pdffillgrid
        do kk=1,12
          q2=q2hera(kk)
          bmin=q2/ecm**2
          bmax=xmax
          bin=(log(bmax)-log(bmin))/(nbin-1)
          do klum=1,3
            do nn=1,nbin
              xb=bmin*exp(bin*(nn-1))
              yb=q2/(ecm)**2/xb
              yplus=1+(1-yb)**2
              if (klum.eq.1) termplus(klum,kk,kpdfset,nn)
     =    =f2charm_ffn(xb,q2,8)    !  F_2,cc
              if (klum.eq.2) termplus(klum,kk,kpdfset,nn)
     =    =flcharm_ffn(xb,q2,8)    !  F_l,cc
              if (klum.eq.3) termplus(klum,kk,kpdfset,nn)
     =    =f2charm_ffn(xb,q2,8)-yb**2/yplus*flcharm_ffn(xb,q2,8)
            end do
          end do
        end do
      end do

      print *,'The electron-proton DIS c-quark NC semi-inclusive', 
     -' structure functions', 
     -' in the NNLO QCD approximation and the running-mass definition',
     -' (first column: the momentum transferred squared, the second',
     -' column: the value of Bjorken'
     -,' variable x, the third column: the value of F_2,' 
     -,' the fourth column: the value of F_L,' 
     -,' the fifth column: the value of reduced c.s.=F_2-Y**2/Y_+*F_L' 

      do kk=1,12
        q2=q2hera(kk)
        bmin=q2/ecm**2
        bmax=xmax
        bin=(log(bmax)-log(bmin))/(nbin-1)
        do i=1,nbin
          xb=bmin*exp(bin*(i-1))
          do klum=1,3
            termdisp(klum,1,i)=0.

            do kpdfset=1,npdftot          
              termdisp(klum,kk,i)=termdisp(klum,kk,i)
     +       +(termplus(klum,kk,kpdfset,i)-termplus(klum,kk,0,i))**2
            enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABM11)|| defined(ABM12)
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i))
#else
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i)/2.)
#endif

          end do

        write (*,fmt='(2e13.4,6(e13.4,a2,e10.4))') xb,q2
     ,        ,(termplus(ll,kk,0,i),'+-',termdisp(ll,kk,i),ll=1,3)
        end do
      end do

      stop
      end
